/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: pylabelset.c,v 1.3 2000/08/01 10:10:36 bazsi Exp $
 *
 ***************************************************************************/

#include <zorp/zpython.h>
#include <zorp/labelset.h>
#include <zorp/log.h>

extern PyTypeObject z_py_zorp_label_set_type;

PyObject *
z_py_zorp_label_set_new(ZLabelSet *labelset)
{
  ZorpLabelSet *self;

  self = PyObject_NEW(ZorpLabelSet, &z_py_zorp_label_set_type);
  self->labelset = z_label_set_ref(labelset);
  return (PyObject *) self;
}

static void
z_py_zorp_label_set_free(ZorpLabelSet *self)
{
  z_label_set_unref(self->labelset);
  PyMem_DEL(self);
}

static PyObject *
z_py_zorp_label_set_getattr(PyObject *o, char *name)
{
  return NULL;
}

static gint
z_py_zorp_label_set_setattr(PyObject *o, char *name, PyObject *value)
{
  return -1;
}

PyTypeObject z_py_zorp_label_set_type =
{
  PyObject_HEAD_INIT(&PyType_Type)
  0,                                        /*ob_size*/
  "ZorpLabelSet",                             /*tp_name*/
  sizeof(ZorpLabelSet),                       /*tp_basicsize*/
  0,                                        /*tp_itemsize*/
  /* methods */
  (destructor)z_py_zorp_label_set_free,        /*tp_dealloc*/
  (printfunc)0,                             /*tp_print*/
  (getattrfunc)z_py_zorp_label_set_getattr,    /*tp_getattr*/
  (setattrfunc)z_py_zorp_label_set_setattr,    /*tp_setattr*/
  (cmpfunc)0,                               /*tp_compare*/
  (reprfunc)0,                              /*tp_repr*/
  0,                                        /*tp_as_number*/
  0,                   		            /*tp_as_sequence*/
  0,                   		            /*tp_as_mapping*/
  (hashfunc)0,         		            /*tp_hash*/
  (ternaryfunc)0,      		            /*tp_call*/
  (reprfunc)0,         		            /*tp_str*/

  /* Space for future expansion */
  0L,0L,0L,0L,
  "ZorpLabelSet class", /* Documentation string */
};

/*
void
z_py_zorp_label_set_init(void)
{
  Py_InitModule("Zorp.LabelSet", z_py_zorp_label_set_funcs);
}
*/
