############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Plug.py,v 1.10 2000/08/01 10:10:37 bazsi Exp $
##
############################################################################

from Zorp import *
import Service, Connector, Proxy, Session, Stream

class PlugProxy(Proxy.Proxy):
	"""
		Plug tipusu Proxy osztly

		Vltozk:
			stack_proxy			Jelzi, hogy a proxy al van-e rendelve egy
									msiknak.
	"""
	stack_proxy = None

	def __init__(self, session):
		"""
			Ltrehozza az osztly egy pldnyt

			Paramterek:
				session			A kapcsolat adatai

			Lers:
				-

			Visszatrsi rtk:
				-
		"""
		Proxy.Proxy.__init__(self, "plug", session)

	def requestStack(self):
		"""
			Callback fuggveny, ha a proxy alproxy, stackProxy fuggveny
			referencit ad vissza, egyeb esetben 0-t.

			Paramterek:
				-

			Lers:
				Ha a proxy alproxy, akkor stackProxy fuggveny referencit
				ad vissza, egyeb esetben 0.

			Visszatrsi rtk:
				stackproxy fuggveny referencia
		"""
		if self.stack_proxy != None:
			return self.stackProxy
		return 0

	def stackProxy(self, client_fd, server_fd):
		"""
			Ltrehoz egy alproxy sessiont.

			Paramterek:
				client_fd		A kliens fele vezeto fd.
				server_fd		A szerver fele vezet fd.

			Lers:
				Belltja az alproxy-nak a proxyk fele a kapcsolodasi fellett.

			Visszatrsi rtk:
				-
		"""
		debug(0, "stackProxy called: %d, %d" % (client_fd, server_fd))
		subsession = Session.SubSession(self)
		subsession.client_fd = client_fd
		subsession.client = Stream.Stream(client_fd, "plug client upstream")
		subsession.server_fd = server_fd
		subsession.server = Stream.Stream(server_fd, "plug server upstream")
		self.stack_proxy(subsession)
